<!--
 * @Descripttion: (领券记录/tb_customer_coupon)
 * @version: (1.0)
 * @Author: (lwh)
 * @Date: (2023-07-31)
 * @LastEditors: (lwh)
 * @LastEditTime: (2023-07-31)
-->
<template>
  <div class="app-container">
    <el-row :gutter="24">
      <!-- 搜索框 queryParams.需要搜索的字段 -->
      <el-form :model="queryParams" label-position="left" style="margin:15px;"  inline ref="queryForm" v-show="showSearch"
        @submit.prevent>
      <el-form-item label="是否过期" prop="customerCouponIsExpired">
        <el-select v-model="queryParams.customerCouponIsExpired" placeholder="请选择是否过期" clearable @change="handleQuery">
          <el-option v-for="item in  is_expired " :key="item.dictValue" :label="item.dictLabel" :value="item.dictValue"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="是否已使用" prop="customerCouponIsUsed">
        <el-select v-model="queryParams.customerCouponIsUsed" placeholder="请选择是否已使用" clearable @change="handleQuery">
          <el-option v-for="item in  is_used " :key="item.dictValue" :label="item.dictLabel" :value="item.dictValue"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button icon="search" type="primary" @click="handleQuery">{{ $t('btn.search') }}</el-button>
        <el-button icon="refresh" @click="resetQuery">{{ $t('btn.reset') }}</el-button>
      </el-form-item>
      </el-form>
    </el-row>

    <!-- 工具按钮 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" v-hasPermi="['business:customercoupon:addOrUpdate']" plain icon="plus" @click="AddDialogVisible = true">
          {{ $t('btn.add') }}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" :disabled="multiple" v-hasPermi="['business:customercoupon:delete']" plain icon="delete" @click="handleDelete">
          {{ $t('btn.delete') }}
        </el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 表格渲染  prop="对应的字段"-->
    <el-table v-loading="loading" :data="dataList" ref="tableRef" border highlight-current-row @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="50" align="center" />
	  
      <el-table-column prop="couponName" label="优惠劵名称" align="center" :show-overflow-tooltip="true" />
      <el-table-column prop="customerName" label="客户名称" align="center" :show-overflow-tooltip="true" />
      <el-table-column prop="customerCouponIsExpired" label="是否过期" align="center">
        <template #default="scope">
          <dict-tag :options=" is_expired " :value="scope.row.customerCouponIsExpired" />
        </template>
      </el-table-column>
      <el-table-column prop="customerCouponIsUsed" label="是否已使用" align="center">
        <template #default="scope">
          <dict-tag :options=" is_used " :value="scope.row.customerCouponIsUsed" />
        </template>
      </el-table-column>

      <el-table-column label="操作" width="350" fixed="right">
        <template #default="scope">
          <el-button type="primary" size="small" icon="edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['business:customercoupon:addOrUpdate']">编辑</el-button>
          <el-button type="danger" size="small" icon="delete" @click="handleDelete(scope.row)"
            v-hasPermi="['business:customercoupon:delete']">删除</el-button>
          <el-button size="small" icon="view" @click="handleDetail(scope.row)">查看</el-button>
        </template>
      </el-table-column>

    </el-table>
    <pagination :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />
  </div>
  
  <!-- 添加 -->
  <AddDialog v-model="AddDialogVisible" :done="() => resetQuery()"></AddDialog>
  <!-- 编辑 -->
  <EditDialog v-model="EditDialogVisible" :data="EditDialogRow" :done="() => resetQuery()"></EditDialog>
  <!-- 详情 -->
  <DetailDialog v-model="DetailDialogVisible" :data="DetailDialogRow" :done="() => resetQuery()"></DetailDialog>
</template>
<script setup name="customercoupon">
import { ElMessageBox } from 'element-plus'
import modal from '@/plugins/modal.js'
import {    customerCouponList , delCustomerCoupon } from '@/api/business/Marketing/CouponManage/CustomerCoupons/customerCoupon.js'
import AddDialog from "./components/AddDialog.vue";
import EditDialog from "./components/EditDialog.vue";
import DetailDialog from "./components/DetailDialog.vue";

const AddDialogVisible = ref(false);
const EditDialogVisible = ref(false);
const EditDialogRow = ref({});
const DetailDialogVisible = ref(false);
const DetailDialogRow = ref({});

const { proxy } = getCurrentInstance()

// 选中categoryId数组数组
const ids = ref([])
// 非单选禁用
const single = ref(true)
// 非多个禁用
const multiple = ref(true)
// 显示搜索条件
const showSearch = ref(true)
// 数据列表
const dataList = ref([])
// 总记录数
const total = ref(0)
// 是否加载
const loading = ref(true)

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10
  },
})
const { queryParams } = toRefs(data)

// 业务参数


// 业务方法

// 字典获取
const is_expired = ref([]);
async function getis_expired() {
  await proxy.getDicts('is_expired').then((res) => {
    is_expired.value = res.data
  })
}
getis_expired()
// 字典获取
const is_used = ref([]);
async function getis_used() {
  await proxy.getDicts('is_used').then((res) => {
    is_used.value = res.data
  })
}
getis_used()




//基础方法

// 查询数据
function getList() {
  loading.value = true

                                                            
  customerCouponList(queryParams.value).then((res) => {
    if (res.code == 200) {
      loading.value = false;
      dataList.value = res.data.result;
      total.value = res.data.totalNum;
    }
  });
}


// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.customerCouponId)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 重置查询操作 */
function resetQuery() {
  proxy.resetForm('queryForm')
  handleQuery()
}
/** 搜索按钮操作 */
function handleQuery() {
  getList()
}
/** 删除按钮操作 */
function handleDelete(row) {
  const Ids = row.customerCouponId || ids.value

    ElMessageBox.confirm("是否确认删除？", "系统提示", {
      confirmButtonText: '确定',
      cancelButtonText: '取消',
      type: "warning",
    })
    .then(function () {
      return delCustomerCoupon(Ids)
    })
    .then(() => {
      handleQuery()
      modal.msgSuccess("删除成功")
    })
    .catch(() => { })
}



// 修改
function handleUpdate(row) {
  EditDialogVisible.value = true
  EditDialogRow.value = row
}

// 详情
function handleDetail(row) {
  DetailDialogVisible.value = true
  DetailDialogRow.value = row
}

handleQuery()
</script>
